         PRINT NOGEN
         BEGIN NAME=CPCD,IBM=YES,VERSION=40                    @411.088
***********************************************************************
*          THIS PRODUCT CONTAINS "RESTRICTED MATERIALS OF IBM"        *
*          COPYRIGHT = 5748-T14 (C) COPYRIGHT IBM CORP 1979,1993      *
*          LICENSED MATERIAL - PROGRAM PROPERTY OF IBM                *
*          REFER TO COPYRIGHT INSTRUCTIONS FORM NUMBER G120-2083      *
*          US GOVERNMENT USERS RESTRICTED RIGHTS -                    *
*          USE, DUPLICATION OR DISCLOSURE RESTRICTED BY               *
*          GSA ADP SCHEDULE CONTRACT WITH IBM CORP.                   *
***********************************************************************
**** START OF APAR HISTORY ********************************************
*                                                                     *
*     APAR       DATE       DESCRIPTION                               *
*                                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
**** END OF APAR HISTORY **********************************************
         CZ1CP
         EJECT
***********************************************************************
*
*   MODULE NAME = CPCD
*
*   DESCRIPTIVE NAME = PROCESSES VM/CP COMMANDS ON TPF PRC
*
*        INVOKED BY : ZCPCD
*
*   DOCUMENT NAME = NONE
*
*                                                                     *
*
*               PROGRAM PROPERTY OF IBM - DISTRIBUTED AS SAMPLE CODE
*               DISTRIBUTED AS IS - NO WARRANTEE OR SERVICE IS IMPLIED
*
*   FUNCTION OF MODULE: SENDS VM/CP COMMANDS TO VM VIA DIAG 8
*
*   INTERNAL USAGE:
*     INPUT
*
*        ECB DATA LEVELS
*                   D0 -- INPUT MESSAGE ADDR
*
*        REGISTERS
*                    R1  -- PTR TO INPUT MSG
*                    R7  -- PTR TO ZMSG
*
*   MODULE ATTRIBUTES:
*        TYPE : ECB CONTROLLED
*        ALLOCATION (RECOMMENDED)
*             SIZE  (1055)
*             RESIDENCY (FILE)
*        ENVIRONMENT (OPERATING)
*             MASS - SS UNIQUE
*        ENTRY POINT(S) - FUNCTIONAL MESSAGE TABLE
*
*********************************************************************
*
*   EXIT-NORMAL = EXITC
*
*   CHANGE-ACTIVITY = SEE BELOW
*
*        APAR      DATE      DESCRIPTION
*        XXXXXX    XX/XX/XX  --------------------------------
*
*********************************************************************
         SPACE 5
         SYSTC SBVMXA,IFOFF=CPCDERR
         LA    R7,CM1PAC+1(R1)         LOAD ADDR OF STORAGE BLOCK
*                                      WTOPC FOR ALL ZCPCD MSGS
         GETCC DB,L2                   GET CORE BLOCK FOR WTOPC OUT
         ST    R14,EBW012              SAVE ADDR FOR OUTPUTTING
         GETCC DA,L4                   GET CORE BLOCK FOR DIAG OUT
         ST    R14,EBW016              SAVE ADDR FOR OUTPUTTING
         LR    R3,R14                  SAVE BLOCK ADDR
         MONTC                         SET SUPERVISOR STATE KEY 0
         LRA   R3,0(,R3)               LOAD REAL ADDR FOR DIAG
         LR    R2,R7                   GET ADDR OF INPUT
         LA    R2,5(,R2)               POINT TO CP CMD
         LRA   R2,0(,R2)               LOAD REAL ADDR FOR DIAG
         LH    R4,CM1CCT(R1)           LOAD CMD LENGTH
         S     R4,=A(10)               SUBTRACT ZMSG LENGTH
*                                      AND HEADER LENGTH
         O     R4,=X'40000000'         INDICATE RETURN RESPONSE
         L     R5,=A(4095)             LENGTH OF RESPONSE BUFFER
         DC    X'83',X'24',XL2'0008'   DIAG 08 CALL
         LMONC                         GO BACK TO PROBLEM STATE
         WTOPC HEADER=YES,PREFIX=VMCP,NUM=01,LET=I,CHAIN=YES,ENDOFM=NO,X
               TEXT='START OF CP COMMAND DISPLAY'
         XR    R1,R1                   CLEAR FOR COUNTING
         L     R2,EBW012               LOAD FOR COPY
         LA    R2,1(,R2)               INCREMENT TO SAVE FIRST
*                                      BYTE FOR WTOPC COUNT
         L     R3,EBW016               RELOAD FOR COPY
         MVI   EBW020,X'00'            INITIALIZE OVERFLOW FLAG
         C     R5,=A(4095)             IS THE RETURN COUNT GREATER
*                                      THAN 4K?
         BNH   CPCDLOOP                NO, THEN THERE WAS NO BUFFER
*                                      OVERFLOW, SO JUST GO PROCESS
*                                      THE MESSAGE IN R3.
         L     R5,=A(4095)             RESET R5 TO THE MAXIMUM BLOCK
*                                      SIZE, SO THAT ONLY THAT MUCH
*                                      OF THE BLOCK IS DISPLAYED.
         MVI   EBW020,X'FF'            INDICATE OUTPUT TRUNCATED
CPCDLOOP DS    0H
         LTR   R5,R5                   ANYTHING TO SEND?
         BZ    CPCDEXIT                NO, EXIT
         MVC   0(1,R2),0(R3)           COPY A CHARACTER OF OUTPUT
         CLI   0(R2),#CAR              CARRAIGE RETURN?
         BE    CPCDSEND                YES, GO SEND
         LA    R1,1(,R1)               INCREMENT LOCAL COUNT
         BCTR  R5,R0                   DECREMENT OVERALL COUNT
         LA    R2,1(,R2)               INCREMENT TO NEXT 'TO' CHAR
         LA    R3,1(,R3)               INCREMENT TO NEXT 'FROM' CHAR
         B     CPCDLOOP                GO COPY NEXT CHAR
CPCDSEND DS    0H
         L     R2,EBW012               LOAD TO SEND MESSAGE
         STC   R1,0(R2)                SAVE LOCAL COUNT
         WTOPC TEXTA=(R2),CHAIN=YES,HEADER=NO,ENDOFM=NO
*                                      SEND ONE LINE OF OUTPUT
         BCTR  R5,R0                   DECREMENT OVERALL COUNT
         XR    R1,R1                   CLEAR FOR COUNTING
         L     R2,EBW012               LOAD FOR COPY
         LA    R2,1(,R2)               INCREMENT TO SAVE FIRST
*                                      BYTE FOR WTOPC COUNT
         LA    R3,1(,R3)               INCREMENT TO NEXT CHAR
         B     CPCDLOOP                GO COPY NEXT CHAR
CPCDERR  DS    0H
         WTOPC HEADER=YES,PREFIX=VMCP,NUM=04,LET=E,                    X
               TEXT='ERROR - TPF IS NOT RUNNING AS A VM GUEST'
         B     CPCDEXTC                GO EXIT
CPCDEXIT DS    0H
         CLI   EBW020,X'FF'            DOES TRUNCATION FLAG
*                                      INDICATE OVERFLOW?
         BE    CPCDEXT2                YES, GIVE APPROPRIATE
*                                      END OF DISPLAY MESSAGE
         WTOPC HEADER=YES,PREFIX=VMCP,NUM=02,LET=I,CHAIN=YES,          X
               ENDOFM=YES,TEXT='END OF CPCD DISPLAY'
         B     CPCDEXTC                GO EXIT
CPCDEXT2 DS    0H
         WTOPC HEADER=YES,PREFIX=VMCP,NUM=03,LET=W,CHAIN=YES,          X
               ENDOFM=YES,TEXT='END OF CPCD DISPLAY - OUTPUT TRUNCATED'
CPCDEXTC DS    0H
         EXITC
         LTORG
         FINIS CPCD
         END
